--- /dev/null	Sat May 10 12:09:19 2014
+++ new/usr/src/lib/libm/common/complex/ccos.c	Sat May 10 12:09:19 2014
@@ -0,0 +1,55 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+#pragma weak ccos = __ccos
+
+/* INDENT OFF */
+/*
+ * dcomplex ccos(dcomplex z);
+ *
+ * z := x+iy; since ccos(iz) = cosh(z), we have
+ * ccos(z)	= ccos((-1)*(-z)) = ccos(i*i*(-z))
+ *		= ccosh(i*(-z)) = ccosh(i*(-x-yi))
+ *		= ccosh(y-ix)
+ */
+/* INDENT ON */
+
+#include "libm.h"
+#include "complex_wrapper.h"
+
+dcomplex
+ccos(dcomplex z) {
+	double x, y;
+
+	x = D_RE(z);
+	y = D_IM(z);
+	D_RE(z) = y;
+	D_IM(z) = -x;
+	return (ccosh(z));
+}
